from django.core.extensions import get_object_or_404, render_to_response, get_list_or_404
from django.core import formfields
from django.utils.httpwrappers import HttpResponse
from django.models.blog import posts, tags, comments
from django.utils.httpwrappers import HttpResponseRedirect
from datetime import datetime

def single(request, slug, year, month, day):
	post = get_object_or_404(posts, slug__exact=slug, published_at__year=year, published_at__month=month, published_at__day=day)
	manipulator = comments.AddManipulator()
	if request.POST:
		form_data = request.POST.copy()
		errors = manipulator.get_validation_errors(form_data)
		if not errors:
    			manipulator.do_html2python(form_data)
    			manipulator.save(form_data)
        		return HttpResponseRedirect(post.get_absolute_url())
	else:
    		errors = form_data = {}
	form = formfields.FormWrapper(manipulator, form_data, errors)
	return render_to_response('blog/single', {'post': post, 'errors': errors, 'form': form})

def posts_by_tag(request, tag):
	post_list = get_list_or_404(posts, tags__label__iexact=tag)
	return render_to_response('blog/posts_list', {'object_list': post_list })
